<%@ page language="java" import="java.util.*" pageEncoding="utf-8"%>
<%
    String path = request.getContextPath();
    String basePath = request.getScheme()+"://"+request.getServerName()+":"+request.getServerPort()+path+"/";
%>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
    <base href="<%=basePath%>">

    <title>My JSP 'login.jsp' starting page</title>

    <meta http-equiv="pragma" content="no-cache">
    <meta http-equiv="cache-control" content="no-cache">
    <meta http-equiv="expires" content="0">
    <meta http-equiv="keywords" content="keyword1,keyword2,keyword3">
    <meta http-equiv="description" content="This is my page">
    <meta http-equiv="X-UA-Compatible" content="IE=10" />
</head>
<script type="text/javascript" src="js/jquery1.12.4.js"></script>
<script type="text/javascript" src="js/json2.js"></script>
<script type="text/javascript" src="js/jquery.xdomainrequest.min.js"></script>
<script type="text/javascript" src="js/sense-web-server.js"></script>
<script type="text/javascript">

    <%
             String random_value = (String)session.getAttribute("random");
             session.setAttribute("random_number",random_value);
         %>
    var random_value = '<%=random_value %>'
    var sense_web = SenseWeb();
    sense_web.port = 9080;
    sense_web.request_schema = "https://";

    var license_id = 123; //需要改成指定加密锁内的许可id号

    var local_desc = undefined;

    var shell_num = undefined;
    var lock_sn = undefined;
    var lock_cert = undefined;
    var device_certs = undefined;
    var verify_data = undefined;
    var pub_data_size = undefined;
    var pub_data = undefined;

    function verify_param() {
        if (shell_num == undefined || lock_sn == undefined || lock_cert == undefined
            || device_certs == undefined || verify_data == undefined
            || pub_data_size == undefined || pub_data == undefined )
            return;

        form = {
            "shell_num": shell_num,
            "lock_sn": lock_sn,
            "lock_cert": lock_cert,
            "device_certs": device_certs,
            "verify_data": verify_data,
            "pub_data": pub_data,
            "pub_data_size": pub_data_size
        };

        var authform = $("<form></form>")
        authform.attr("method", "post");
        authform.attr("action","/checkValid");

        $.each(form,
            function (key, value) {
                var input = $("<input>");
                input.attr("type", "hidden");
                input.attr("name", key);
                input.val(value);

                authform.append(input);
            }
        );

        $(document.body).append(authform);
        authform.submit();
    }



    function getlockcert() {
        sense_web.slm_ctrl_get_device_cert(local_desc,
            function success(data, statusText) {
                var json = JSON.parse(data);
                console.log("cert: " + data);
                if (json["code"] == 0) {
                    lock_cert = json["data"];
                }
                else {
                    alert("获取加密锁证书出错");
                    return;
                }

                verify_param();
            }
        );
    }

    function getlockcertchain() {
        sense_web.get_local_device_p7b(
            function success(data, statusText) {
                console.log("获取证书链：");
                var json = JSON.parse(data);
                console.log("certlist: " + data);
                if (json["code"] == 0) {
                    var detail = JSON.parse(json["data"])[0];
                    device_certs = detail["device_certs"];
                    shell_num = detail["shell_num"];
                    lock_sn = detail["lock_sn"];
                }
                else {
                    alert("获取加密锁证书链出错");
                    return;
                }

                verify_param();
            }
        );
    }

    function getlocksign(signdata) {
        sense_web.slm_ctrl_sign_by_device(local_desc, signdata,
            function success(data, statusText) {
                var json = JSON.parse(data);
                console.log("获取签名数据: " + data);

                if (json["code"] == 0) {
                    verify_data = json["data"];
                }
                else {
                    alert("使用加密锁签名出错");
                    return;
                }

                verify_param();
            }
        );
    }

    function getlock_pubdata() {
        sense_web.slm_get_pub_size(local_desc, license_id,
            function (data, statusText) {
                var json = JSON.parse(data);
                console.log("获取公开区数据大小: " + data);

                if (json["code"] == 0) {
                    pub_data_size = json["data"];
                }
                else {
                    alert("获取公开区数据大小出错");
                    return;
                }
            }
        );

        sense_web.slm_read_pub_data(local_desc, license_id, 0, pub_data_size,
            function (data, statusText) {
                var json = JSON.parse(data);
                console.log("获取公开区数据: " + data);

                if (json["code"] == 0) {
                    pub_data = json["data"];
                }
                else {
                    alert("获取公开区数据");
                    return;
                }
            }
        );

        verify_param();
    }


    function getlockinfo(){

        sense_web.get_local_desc(
            function success(data, statusText) {
                console.log("获取本地锁描述: ");
                var json = JSON.parse(data);

                //获取第一个锁描述用于下面的测试
                if (json["code"] == 0) {
                    local_desc = JSON.parse(json["data"]);
                    if (local_desc.length == 0) {
                        alert("未发现加密锁");
                        return;
                    }
                    else if (local_desc.length != 1) {
                        alert("发现多把加密锁，请拔出其中一把后重试");
                        return;
                    }

                    local_desc = JSON.stringify(JSON.parse(json["data"])[0]);

                    //获取证书
                    getlockcert();
                    //获取证书链
                    getlockcertchain();

                    //获取加密锁签名数据，需要先使用base64进行编码
                    var signdata = window.btoa("SENSELOCK" + random_value);
                    getlocksign(signdata);

                    //获取许可公开区数据
                    getlock_pubdata();
                }
            }
        );
    }
</script>

<body onload="getlockinfo()">
</body>
</html>
